<?php
// IMDb link transformer
// version 1.0, 12-02-2009
//
// (c) 2005-09 Prometheus group
// http://www.ikiru.ch/blog
//
// **********************************************************************
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
// *****************************************************************

/*
Plugin Name: IMDb link transformer
Plugin URI: http://www.ikiru.ch/blog/imdb-link-transformer-wordpress-plugin
Description: Transforms every movie's name tagged &lt;!--imdb--&gt; (...) &lt;!--/imdb--&gt; into a link to an internal <a href="http://www.imdb.com"><acronym title="internet movie database">imdb</acronym></a> popup. Can also display data related to the movie you write about, using a <a href="widgets.php">widget</a>. Perfect for your movies reviews. Cache handling. Have a look to the <a href="options-general.php?page=imdb-link-transformer.php">options page</a>.
Version: 1.0
Author: Psykotik
Author URI: http://www.ikiru.ch/blog
*/ 

// ---------------------
// --------------------- Fonctions
// --------------------- 

include_once ('config.php');

if (class_exists("imdb_settings_conf")) {
	$imdb_ft = new imdb_settings_conf();
	$imdb_configs_values = $imdb_ft->get_imdb_option();
}

/***********
1.- Remplacement des tags <!--imdb--> dans les messages
***********/

##### a) Look for what is inside tags  <!--imdb--> ...  <!--/imdb--> and construct a link to "popup.php"
function parse_imdb_tags($correspondances){
	global $imdb_configs_values;
    
	$correspondances = $correspondances[0];
	preg_match("/<!--imdb-->(.*?)<!--\/imdb-->/i", $correspondances, $link_parsed);

	// link construction
	$link_parsed = "<a class=\"link-imdb\" onclick=\"window.open('".$imdb_configs_values[imdbplugindirectory]."popup.php?film="
    .imdb_htmlize($link_parsed[1])."', 'popup', 'resizable=yes, toolbar=0, scrollbars=yes, status=no, location=no, width=".$imdb_configs_values[popupLarg].", height=".$imdb_configs_values[popupLong].", top=5, left=5')\" title=\"".__('link to imdb informations; opens a new window', 'imdb')."\">".$link_parsed[1]."</a>";

	return $link_parsed;
}

##### b) Replace  <!--imdb--> tags with links to "popup.php"
function imdb_linking($text) {
	$pattern = '/<!--imdb-->(.*?)<!--\/imdb-->/i';
	$text = preg_replace_callback($pattern,'parse_imdb_tags',$text);
	return $text;
}

/***********
2.-  Add tags <!--imdb--> <!--/imdb--> to writing admin page
***********/

##### a) HTML part

function imdb_add_quicktag() { ?>
		<script language="JavaScript" type="text/javascript"><!--
		var toolbar = document.getElementById("ed_toolbar");
		var buttonNumber = 0;
		if(toolbar)
		{
<?php //-------------------- <!--imdb--> part  ?>
			document.getElementById("ed_toolbar").innerHTML += "<input type=\"button\" class=\"imdb_handler\" id=\"imdb_handler\" value=\"imdb\" onclick=\"edInsertTag(edCanvas, 6666); \" />";
			
			edButtons[6666] = 
			new edButton('imdb_handler'
				,'imdb'
				,'<!--imdb-->'
				,'<!--/imdb-->'
				,''
			);
		}
		//--></script>
<?php 
}

##### b) tinymce part (wysiwyg display)

function imdb_addbuttons() {
   // Don't bother doing this stuff if the current user lacks permissions
   if ( ! current_user_can('edit_posts') && ! current_user_can('edit_pages') )
     return;
 
   // Add only in Rich Editor mode
   if ( get_user_option('rich_editing') == 'true') {
     add_filter("mce_external_plugins", "add_imdb_tinymce_plugin");
     add_filter('mce_buttons', 'register_imdb_button');
   }
}
function register_imdb_button($buttons) {
   array_push($buttons, "separator", "imdb");
   return $buttons;
}
// Load the TinyMCE plugin 
function add_imdb_tinymce_plugin($plugin_array) {
   $plugin_array['imdb'] = WP_PLUGIN_URL .'/imdb-link-transformer/tinymce/editor_plugin.js';
   return $plugin_array;
}


/***********
3.-  Allow to call imdb-movie.inc.php page (= widget, but can be placed anywhere)
***********/
function call_imdb_movie ($movieid=1) {
	echo $before_widget;
	echo $before_title . $title . $after_title;
	echo "<div class='imdbincluded'>";
	/*$content = "";
	echo $content;*/
	if (empty($movieid)) { $movieid = get_the_ID (); }
	$_GET ['imdbpostid'] = $movieid; //"movieid" (= post id) will be transmitted to the next include
	include( 'inc/imdb-movie.inc.php');
	echo "</div>";
	echo $after_widget;
}

// ---------------------
// --------------------- filters
// ---------------------

/***********
1.- transform movie's name in a way to be able to be serachable (ie "ô" becomes "&ocirc;") 
***********/ 

function imdb_htmlize ($lien) {
    // a. quotes escape
    $lienhtmlize = addslashes($lien);      
    // b.converts db to html -> no more needed
    //$lienhtmlize = htmlentities($lienhtmlize,ENT_NOQUOTES,"UTF-8");
    // c. regular expression to convert all accents; weird function...
    $lienhtmlize = preg_replace('/&(?!#[0-9]+;)/s', '&amp;', $lienhtmlize);
    // d. turns spaces to "+", which allows titles including several words
	$lienhtmlize = str_replace(array(' '), array('+'), $lienhtmlize);
    
    return $lienhtmlize; 
}

/***********
2.- Add the stylesheet to the head of the pages
***********/ 

##### a) outside admin part
function imdb_add_css () {
	global $imdb_configs_values;

	echo "
	<!-- Added by \"Imdb link transformer\" plugin -->
	<link rel=\"stylesheet\" href=\"".$imdb_configs_values[imdbplugindirectory]."css/imdb.css\" type=\"text/css\" />
    \t<!-- /Added by \"Imdb link transformer\" plugin -->\n";
}

##### b) admin part
function imdb_add_css_admin () {
	global $imdb_configs_values;

	echo "
	<!-- Added by \"Imdb link transformer\" plugin -->
	<link rel=\"stylesheet\" href=\"".$imdb_configs_values[imdbplugindirectory]."css/imdb-admin.css\" type=\"text/css\" />
    \t<!-- /Added by \"Imdb link transformer\" plugin -->\n";
}

/***********
3.- Add the admin menu
***********/

if (!function_exists("imdb_admin_panel")) {
	function imdb_admin_panel() {
		global $imdb_ft;
		if (!isset($imdb_ft)) {
			return;
		}
		if (function_exists('add_options_page')) {
			add_options_page('IMDb link transformer Options', 'IMDb', 8, basename(__FILE__), array(&$imdb_ft, 'printAdminPage'));
		}
	}	
}

/***********
4.- Add the widget
***********/
include_once ('imdb-widget.php');



// ---------------------
// --------------------- Automatisms & executions
// ---------------------

// Be sure WP is running
if (function_exists('add_action')) {
    // javascript for main blog
	add_action('wp_head', 'imdb_add_css');
	add_filter('the_content', 'imdb_linking', 2);
	add_filter('the_excerpt', 'imdb_linking', 2);
	// admin menu
	if (isset($imdb_ft)) {
	 	add_action('admin_head', 'imdb_add_css_admin');
		add_action('admin_menu', 'imdb_admin_panel');
		//add_action('activate_imdb/imdb-link-transformer.php',  array(&$imdb_ft, 'init'));		//-no more needed ?
		//register_activation_hook('imdb/imdb-link-transformer.php',  array(&$imdb_ft, 'init'));//-same as above
	}
	// buttons
	add_action('admin_footer', 'imdb_add_quicktag');
	add_action('init', 'imdb_addbuttons');
    // delete this one if you don't want IMDB link transformer to be run on comments
	add_filter('comment_text', 'imdb_linking', 10);
	// Widget
	add_action('plugins_loaded', 'register_imdbwidget');
}

// ---------------------
// --------------------- Function for external calls (the imdb widget)
// ---------------------
function imdb_external_call () {
global $imdb_configs_values, $wp_query;
$filmid = $wp_query->post->ID;
$imdballmeta = get_post_meta($filmid, 'imdb-movie-widget', false);
echo "<div class='imdbincluded'>";
include ( "inc/imdb-movie.inc.php" );
echo "</div>";
}

?>
