<?php
	/**
	Registers our widget so it appears with the other available
	widgets and can be dragged and dropped into any active sidebars
	*/
	function widget_imdbwidget($args) {
		global $imdb_configs_values, $wp_query;
		extract($args);
		$options = get_option('widget_imdbwidget');
		$title = empty($options['title']) ? __('IMDb data') : $options['title'];

		$filmid = $wp_query->post->ID;

		if ( ((is_single()) OR (is_page())) && ($imdb_configs_values[imdbdirectsearch] == true) && (get_post_meta($filmid, 'imdb-movie-widget', true)) ){
		// shows widget only for a post or a page, when option "direct search" is set up, 
		// and if meta tag "imdb-movie-widget" can be found
			$imdballmeta = get_post_meta($filmid, 'imdb-movie-widget', false);
			echo $before_widget;
			echo $before_title . $title . $after_title;
			echo "<div class='imdbincluded'>";
			/*$content = "";
			echo $content;*/
			include( 'inc/imdb-movie.inc.php');
			echo "</div>";
			echo $after_widget;
		}
	}

	/**
	Register the optional widget control form
	*/
	function widget_imdbwidget_control() {
		$options = $newoptions = get_option('widget_imdbwidget');
		if ($_POST["imdbW-submit"]) {
			$newoptions['title'] = strip_tags(stripslashes($_POST["imdbW-title"]));
		}
		if ($options != $newoptions) {
			$options = $newoptions;
			update_option('widget_imdbwidget', $options);
		}
		$title = htmlspecialchars($options['title'], ENT_QUOTES);
		echo "<p><label for=\"imdbW-title\">" . __('Title:');
		echo "<input style=\"width: 250px;\" id=\"imdbW-title\" name=\"imdbW-title\" type=\"text\" value=\"" . $title . "\" /></label></p>";
		echo "<input type=\"hidden\" id=\"imdbW-submit\" name=\"imdbW-submit\" value=\"1\" />";
	}

	/**
	Register the Widget into the WordPress Widget API
	*/
	function register_imdbwidget() {
		//Check Sidebar Widget and Subscribe2 plugins are activated
		if ( !function_exists('register_sidebar_widget') || !class_exists('imdb_settings_conf')) {
			return;
		} else {
			register_sidebar_widget('IMDb Widget', 'widget_imdbwidget');
			register_widget_control('IMDb Widget', 'widget_imdbwidget_control');
		}
	}

	function plugin_action($links, $file) {
		if ($file == plugin_basename(dirname(__FILE__).'/imdb-link-transformer.php'))
			$links[] = "<a href='options-general.php?page=imdb-link-transformer/imdb-link-transformer.php'><b>" . __('Settings', 'Imdb link transformer') . "</b></a>";
		return $links;
	}
	
?>